/*
**	Copyright (C) 1987, 1988 Kinetics, Inc.  All Rights Reserved.
**	This program contains proprietary confidential information
**	and trade secrets of Kinetics, Inc.  Reverse engineering
**	of object code is prohibited.  Use of copyright notice
**	is precautionary and does not imply publication.
**
**
**	Indices into the jump table for PROM routines.
**	Also, the command numbers for the routines when invoked
**	from Kinetics LAP type command packets.
**
**	NOTE:	this include file is used in assembly source as
**		well as C source, and so may not contain any C-dependent
**		definitions.
*/

/* number of mc68000 vectors we support: */
#define NUMVECS	64

/* number of entries in subroutine table: */
#define	NUMKCMDS	150

/* commands commented with KLAP are callable as remote procedures: */
#define	X_VERSION	 0		/* KLAP */
#define	X_EXECUTE	 1		/* KLAP */
#define	X_ACK		 2		/* OBSOLETE */
#define	X_REBOOT	 3		/* KLAP */
#define	X_SET68		 4
#define	X_SET86		 5
#define	X_ATINIT	 6
#define	X_ATWRITE	 7
#define	X_WAIT		 8		/* KLAP */
#define	X_WHEREIS	 9		/* KLAP */
#define	X_GETMEM	10		/* KLAP */
#define	X_PROTECT	11		/* KLAP */
#define	X_COPYMEM	12		/* KLAP */
#define	X_CLRMEM	13		/* KLAP */
#define	X_PROMRAM	14		/* KLAP */
#define	X_RESET		15		/* KLAP */
#define	X_USER0		16		/* KLAP */
#define	X_USER1		17		/* KLAP */
#define	X_USER2		18		/* KLAP */
#define	X_USER3		19		/* KLAP */
#define	X_USER4		20		/* KLAP */
#define	X_USER5		21		/* KLAP */
#define	X_USER6		22		/* KLAP */
#define	X_USER7		23		/* KLAP */
#define	X_BUFINIT	24
#define	X_BUFGET	25
#define	X_BUFFREE	26
#define	X_BUFENQ	27
#define	X_BUFDEQ	28
#define	X_ERR		29		/* KLAP */
#define	X_IDLE		30		/* KLAP */
#define	X_KLAP		31
#define	X_WHO		32		/* KLAP */
#define	X_CA86		33
#define	X_RES86		34
#define	X_CLRINT	35
#define	X_RCSID		36		/* KLAP */
#define	X_EXPROM	37		/* KLAP */
#define	X_INIPROM	38		/* KLAP */
#define	X_RES8530	39
#define	X_DMTSERV	40
#define	X_SREC		41		/* KLAP */
#define	X_SPL		42		/* KLAP */
#define	X_LED		43
#define	X_RAND		44		/* KLAP */
#define	X_CMPMEM	45		/* KLAP */
#define	X_SENDF		46
#define	X_MEMSEG	47
#define	X_MALLOC	48
#define	X_FREE		49
#define	X_IE_INIT	50
#define	X_IEXSTART	51
#define	X_KLAP2		52
#define	X_PROM1_CHECK	53
#define	X_PROM1_EXECUTE	54		/* KLAP */
#define	X_ARPINIT	55
#define	X_ARPINPUT	56
#define	X_ARPRESOLVE	57
#define	X_ARPTIMER	58
#define	X_ISIPAARP	59
#define	X_ETINIT	60
#define	X_TIMING	61
#define	X_ARPDUMP	62		/* KLAP */
#define	X_ROUTEDDP	63
#define	X_NBPINIT	64
#define	X_NBPINPUT	65
#define	X_RTMPINIT	66
#define	X_RTMPINPUT	67
#define	X_RTMPRESPONSE	68
#define	X_RTMPTIMER	69
#define	X_ZIPINIT	70
#define	X_ZIPINPUT	71
#define	X_ZIPTIMER	72
#define	X_ATPINIT	73
#define	X_ATPINPUT	74
#define	X_ECHOINIT	75
#define	X_ECHOINPUT	76
#define	X_DDPIPINIT	77
#define	X_ROUTEDDPINIT	78
#define	X_AUTOCINIT	79
#define	X_HASHINIT	80
#define	X_NEWHASHTABLE	81
#define	X_LOOKUP	82
#define	X_ADD		83
#define	X_REMOVE	84
#define	X_FIRST		85
#define	X_NEXT		86
#define	X_NETLOOKUP	87
#define	X_RMRTMP	88
#define	X_RTMPREPLACE	89
#define	X_ADDNET	90
#define	X_RMNET		91
#define	X_FINDZONE	92
#define	X_AUTOCONF	93
#define	X_RESET_AUTOCONF	94
#define	X_DDPREPLY	95
#define	X_ROUTEIP	96
#define	X_ISSAMEZONE	97
#define	X_CHECKSUM	98
#define	X_WHERE2	99		/* KLAP */
#define	X_GETCFGSUM	100		/* KLAP */
#define	X_SETCFGSUM	101		/* KLAP */
#define	X_DMSG		102		/* KLAP */
#define	X_STATE		103		/* KLAP */
#define	X_HWSTATUS	104		/* KLAP */
#define	X_SENDFINIT	105
#define	X_IESTATS	106		/* KLAP */
#define	X_AATWRITE	107
#define	X_ALLBUFS	108
#define	X_MAKEBUFS	109
#define	X_CLRPROTSTATS	110		/* KLAP */
#define	X_GETPROTSTATS	111		/* KLAP */
#define	X_SIZEMEM	112		/* KLAP */
#define	X_SETACKLEN	113
#define	X_IDENT		114		/* KLAP */
#define	X_SETMCAST	115		/* KLAP */
#define	X_NOTIMP	(NUMKCMDS-1)
