/*
**	Copyright (C) 1987 Kinetics, Inc.  All Rights Reserved.
**	This program contains proprietary confidential information
**	and trade secrets of Kinetics, Inc.  Reverse engineering
**	of object code is prohibited.  Use of copyright notice
**	is precautionary and does not imply publication.
**
**
** The PROM loader guarantees the following to be true when the
** downloaded program begins executing:
**
**	- CPU is in supervisor state,
**	- Interrupt service is at level 7
**	- 'sp' contains the address of the boot prom 'jump_table'
**	  defined below
**
**	NOTE:  this file included by assembly and C source,
**	all C statements are to be bracketed by ASM_INCLUDE
*/

#include <cmdidx.h>		/* use the position dependent command
				** indices for the X_nnn constants
				*/
#ifndef	ASM_INCLUDE
struct fp_table {
	struct {
		unsigned short opcode;
		unsigned long dst_addr;
		} jump_table[NUMVECS];/* one jump per mc68000 vector */

	int (*subr_table[NUMKCMDS])();
	char rpctab[NUMKCMDS];		/* 1 indicates corresponding routine
					** can be called via KLAP, 0 indicates
					** subroutine only
					*/
};

extern struct fp_table *table_ptr;

#define	K_VERSION(a)	table_ptr->subr_table[X_VERSION](a)
#define	K_EXECUTE()	table_ptr->subr_table[X_EXECUTE]()
#define	K_ACK()		table_ptr->subr_table[X_ACK]()
#define	K_REBOOT()	table_ptr->subr_table[X_REBOOT]()
#define	K_SET68()	table_ptr->subr_table[X_SET68]()
#define	K_SET86(a)	table_ptr->subr_table[X_SET86](a)
#define	K_ATINIT(a)	table_ptr->subr_table[X_ATINIT](a)
#define	K_ATWRITE(a)	table_ptr->subr_table[X_ATWRITE](a)
#define	K_WAIT(a)	table_ptr->subr_table[X_WAIT](a)
#define	K_WHEREIS(a)	table_ptr->subr_table[X_WHEREIS](a)
#define	K_GETMEM(a)	table_ptr->subr_table[X_GETMEM](a)
#define	K_PROTECT(a)	table_ptr->subr_table[X_PROTECT](a)
#define	K_COPYMEM(a)	table_ptr->subr_table[X_COPYMEM](a)
#define	K_CLRMEM(a)	table_ptr->subr_table[X_CLRMEM](a)
#define	K_PROMRAM(a)	table_ptr->subr_table[X_PROMRAM](a)
#define	K_RESET()	table_ptr->subr_table[X_RESET]()
#define	K_USER0(a)	table_ptr->subr_table[X_USER0](a)
#define	K_USER1(a)	table_ptr->subr_table[X_USER1](a)
#define	K_USER2(a)	table_ptr->subr_table[X_USER2](a)
#define	K_USER3(a)	table_ptr->subr_table[X_USER3](a)
#define	K_USER4(a)	table_ptr->subr_table[X_USER4](a)
#define	K_USER5(a)	table_ptr->subr_table[X_USER5](a)
#define	K_USER6(a)	table_ptr->subr_table[X_USER6](a)
#define	K_USER7(a)	table_ptr->subr_table[X_USER7](a)
#define	K_BUFINIT(a)	table_ptr->subr_table[X_BUFINIT](a)
#define	K_BUFGET(a)	table_ptr->subr_table[X_BUFGET](a)
#define	K_BUFFREE(a)	table_ptr->subr_table[X_BUFFREE](a)
#define	K_BUFENQ(a)	table_ptr->subr_table[X_BUFENQ](a)
#define	K_BUFDEQ(a)	table_ptr->subr_table[X_BUFDEQ](a)
#define	K_ERR()		table_ptr->subr_table[X_ERR]()
#define	K_IDLE()	table_ptr->subr_table[X_IDLE]()
#define	K_KLAP(a)	table_ptr->subr_table[X_KLAP](a)
#define	K_WHO()		table_ptr->subr_table[X_WHO]()
#define	K_CA86()	table_ptr->subr_table[X_CA86]()
#define	K_RES86()	table_ptr->subr_table[X_RES86]()
#define	K_CLRINT()	table_ptr->subr_table[X_CLRINT]()
#define	K_RCSID(a)	table_ptr->subr_table[X_RCSID](a)
#define	K_EXPROM()	table_ptr->subr_table[X_EXPROM]()
#define	K_INIPROM()	table_ptr->subr_table[X_INIPROM]()
#define	K_RES8530()	table_ptr->subr_table[X_RES8530]()
#define	K_DMTSERV()	table_ptr->subr_table[X_DMTSERV]()
#define	K_SREC(a)	table_ptr->subr_table[X_SREC](a)
#define	K_SPL(a)	table_ptr->subr_table[X_SPL](a)
#define	K_LED(a)	table_ptr->subr_table[X_LED](a)
#define	K_RAND(a)	table_ptr->subr_table[X_RAND](a)
#define	K_CMPMEM(a)	table_ptr->subr_table[X_CMPMEM](a)
#define	K_SENDF(a)	table_ptr->subr_table[X_SENDF](a)
#define	K_MEMSEG(a)	table_ptr->subr_table[X_MEMSEG](a)
#define	K_MALLOC(a)	table_ptr->subr_table[X_MALLOC](a)
#define	K_FREE(a)	table_ptr->subr_table[X_FREE](a)
#define	K_IE_INIT(a)	table_ptr->subr_table[X_IE_INIT](a)
#define	K_IEXSTART(a)	table_ptr->subr_table[X_IEXSTART](a)
#define	K_KLAP2(a)	table_ptr->subr_table[X_KLAP2](a)
#define	K_PROM1_CHECK(a)	table_ptr->subr_table[X_PROM1_CHECK](a)
#define	K_PROM1_EXECUTE()	table_ptr->subr_table[X_PROM1_EXECUTE]()
#define	K_ARPINIT(a)	table_ptr->subr_table[X_ARPINIT](a)
#define	K_ARPINPUT(a)	table_ptr->subr_table[X_ARPINPUT](a)
#define	K_ARPRESOLVE(a)	table_ptr->subr_table[X_ARPRESOLVE](a)
#define	K_ARPTIMER(a)	table_ptr->subr_table[X_ARPTIMER](a)
#define	K_ISIPAARP(a)	table_ptr->subr_table[X_ISIPAARP](a)
#define	K_ARPDUMP()	table_ptr->subr_table[X_ARPDUMP]()
#define	K_ETINIT(a)	table_ptr->subr_table[X_ETINIT](a)
#define	K_TIMING(a)	table_ptr->subr_table[X_TIMING](a)
#define	K_ROUTEDDP(a)	table_ptr->subr_table[X_ROUTEDDP](a)
#define	K_NBPINIT()	table_ptr->subr_table[X_NBPINIT]()
#define	K_NBPINPUT(a)	table_ptr->subr_table[X_NBPINPUT](a)
#define	K_RTMPINIT(a)	table_ptr->subr_table[X_RTMPINIT](a)
#define	K_RTMPINPUT(a)	table_ptr->subr_table[X_RTMPINPUT](a)
#define	K_RTMPRESPONSE(a)	table_ptr->subr_table[X_RTMPRESPONSE](a)
#define	K_RTMPTIMER()	table_ptr->subr_table[X_RTMPTIMER]()
#define	K_ZIPINIT(a)	table_ptr->subr_table[X_ZIPINIT](a)
#define	K_ZIPINPUT(a)	table_ptr->subr_table[X_ZIPINPUT](a)
#define	K_ZIPTIMER()	table_ptr->subr_table[X_ZIPTIMER]()
#define	K_ATPINIT()	table_ptr->subr_table[X_ATPINIT]()
#define	K_ATPINPUT(a)	table_ptr->subr_table[X_ATPINPUT](a)
#define	K_ECHOINIT(a)	table_ptr->subr_table[X_ECHOINIT](a)
#define	K_ECHOINPUT(a)	table_ptr->subr_table[X_ECHOINPUT](a)
#define	K_DDPIPINIT(a)	table_ptr->subr_table[X_DDPIPINIT](a)
#define	K_ROUTEDDPINIT(a)	table_ptr->subr_table[X_ROUTEDDPINIT](a)
#define	K_AUTOCINIT(a)	table_ptr->subr_table[X_AUTOCINIT](a)
#define	K_HASHINIT()	table_ptr->subr_table[X_HASHINIT]()
#define	K_NEWHASHTABLE(a)	table_ptr->subr_table[X_NEWHASHTABLE](a)
#define	K_LOOKUP(a)	table_ptr->subr_table[X_LOOKUP](a)
#define	K_ADD(a)	table_ptr->subr_table[X_ADD](a)
#define	K_REMOVE(a)	table_ptr->subr_table[X_REMOVE](a)
#define	K_FIRST(a)	table_ptr->subr_table[X_FIRST](a)
#define	K_NEXT(a)	table_ptr->subr_table[X_NEXT](a)
#define	K_NETLOOKUP(a)	table_ptr->subr_table[X_NETLOOKUP](a)
#define	K_RMRTMP(a)	table_ptr->subr_table[X_RMRTMP](a)
#define	K_RTMPREPLACE(a)	table_ptr->subr_table[X_RTMPREPLACE](a)
#define	K_ADDNET(a)	table_ptr->subr_table[X_ADDNET](a)
#define	K_RMNET(a)	table_ptr->subr_table[X_RMNET](a)
#define	K_FINDZONE(a)	table_ptr->subr_table[X_FINDZONE](a)
#define	K_AUTOCONF(a)	table_ptr->subr_table[X_AUTOCONF](a)
#define	K_RESET_AUTOCONF(a)	table_ptr->subr_table[X_RESET_AUTOCONF](a)
#define	K_DDPREPLY(a)	table_ptr->subr_table[X_DDPREPLY](a)
#define	K_ROUTEIP(a)	table_ptr->subr_table[X_ROUTEIP](a)
#define	K_ISSAMEZONE(a)	table_ptr->subr_table[X_ISSAMEZONE](a)
#define	K_CHECKSUM(a)	table_ptr->subr_table[X_CHECKSUM](a)
#define	K_WHERE2(a)	table_ptr->subr_table[X_WHERE2](a)
#define	K_GETCFGSUM(a)	table_ptr->subr_table[X_GETCFGSUM](a)
#define	K_SETCFGSUM()	table_ptr->subr_table[X_SETCFGSUM]()
#define	K_DMSG(a)	table_ptr->subr_table[X_DMSG](a)
#define	K_STATE(a)	table_ptr->subr_table[X_STATE](a)
#define	K_HWSTATUS(a)	table_ptr->subr_table[X_HWSTATUS](a)
#define	K_SENDFINIT()	table_ptr->subr_table[X_SENDFINIT]()
#define	K_IESTATS(a)	table_ptr->subr_table[X_IESTATS](a)
#define	K_AATWRITE(a)	table_ptr->subr_table[X_AATWRITE](a)
#define	K_ALLBUFS(a)	table_ptr->subr_table[X_ALLBUFS](a)
#define	K_MAKEBUFS(a)	table_ptr->subr_table[X_MAKEBUFS](a)
#define	K_CLRPROTSTATS()	table_ptr->subr_table[X_CLRPROTSTATS]()
#define	K_GETPROTSTATS(a)	table_ptr->subr_table[X_GETPROTSTATS](a)
#define	K_SIZEMEM(a)	table_ptr->subr_table[X_SIZEMEM](a)
#define	K_SETACKLEN(a)	table_ptr->subr_table[X_SETACKLEN](a)
#define	K_IDENT(a)	table_ptr->subr_table[X_IDENT](a)
#define	K_SETMCAST(a)	table_ptr->subr_table[X_SETMCAST](a)
#define	K_NOTIMP()	table_ptr->subr_table[X_NOTIMP]()

/* structures and macro definitions for the above commands */

/* X_VERSION */
struct fp_version {
	short	fpv_entries;	    /* number of valid entries in jump table */
	short	fpv_version;	    /* version of the prom code */
	long	fpv_model;	    /* "KFPS", "KFPQ", or "KFPM" */
};

/* X_EXECUTE */
/* no parameters */

/* X_ACK */
/* no parameters */

/* X_REBOOT */
/* no parameters */

/* X_SET68 */
/* no parameters */

/* X_SET86 */
/* this structure is really defined in ie.h, but it should look like this */
#ifdef	NEVER
struct scb {
	unsigned short	sc_status;	/* status */
	unsigned short	sc_cmd;		/* command */
	unsigned short	sc_clist;	/* command list */
	unsigned short	sc_rlist;	/* receive frame list */
	unsigned short	sc_crcerrs;	/* crc errors */
	unsigned short	sc_alnerrs;	/* alignment errors */
	unsigned short	sc_rscerrs;	/* resource errors (lack of rfd/rbd's) */
	unsigned short	sc_ovrnerrs;	/* overrun errors (mem bus not avail) */
};
#endif	NEVER

/* X_ATINIT */
/* The parameter is a pointer to a short which is filled in with
   the node number chosen by the AppleTalk initialization sequence */

/* X_ATWRITE */
struct fp_atwrite {
	short	fpw_length;	/* number of bytes in the following string */
	unsigned char *fpw_str;	/* string to be output onto the network */
};

/* X_WAIT */
/* The parameter is a long integer which indicates
   the number of milliseconds to delay */

/* X_WHEREIS */
struct fp_whereis {
	char	*fpw_rom0;	/* first address of 1st ROM */
	char	*fpw_rom1;	/* first address of 2nd ROM */
	char	*fpw_8530;	/* address of Zilog 8530 chip */
	char	*fpw_0port;	/* address of 1st 8-bit port */
	char	*fpw_1port;	/* address of 2nd 8-bit port */
	char	*fpw_ram2;	/* address of 1st RAM location */
	char	*fpw_ramtop;	/* address of last RAM location */
};

/* X_GETMEM and X_CLRMEM and X_BUFINIT */
struct fp_mem {
	unsigned short fpm_count;	/* number of bytes */
	char	*fpm_memp;	/* addr of allocated or to be cleared memory */
};

/* X_PROTECT */
struct fp_proelem {			/* protection array element */
	unsigned short fpp_count;	/* number of bytes to protect */
	char	*fpp_memp;		/* address of memory to protect */
	unsigned short fpp_chksum;	/* checksum of protected memory */
};

struct fp_protect {
	short	fpt_oper;	/* type of protection operation and result */
	short	fpt_count;	/* number of elements in protection array */
	struct fp_proelem *fpt_elem; /* addr 1st element in protection array */
};
#endif	ASM_INCLUDE

/* fpt_oper operations */
#define	PR_FAIL		-1	/* result: check of checksums failed */
#define	PR_PASS		0	/* result: check of checksums passed */
#define	PR_PROTECT	1	/* operation: start protect via elem array */
#define	PR_CHECK	2	/* operation: verify protect via elem array */
#define	PR_CANCEL	3	/* operation: cancel protect via elem array */

#ifndef	ASM_INCLUDE
/* X_COPYMEM and X_CMPMEM */
struct fp_copy {
	char	*fpc_from;		/* location to copy/cmp bytes from */
	char	*fpc_to;		/* location to copy/cmp bytes to */
	unsigned short fpc_count;	/* number of bytes to copy/cmp */
};

/* macros based on COPYMEM and CMPMEM */
#define	K_BCOPY(addr1,addr2,cnt) { \
	struct fp_copy ab; \
	ab.fpc_from = (char *)(addr1); \
	ab.fpc_to = (char *)(addr2); \
	ab.fpc_count = (unsigned short)(cnt); \
	K_COPYMEM(&ab); \
}

#define	K_BZERO(addr,cnt) { \
	struct fp_mem ab; \
	ab.fpm_count = (unsigned short)(cnt); \
	ab.fpm_memp = (char *)(addr); \
	K_CLRMEM(&ab); \
}

#define	K_BCMP(rv,addr1,addr2,cnt) { \
	struct fp_copy ab; \
	ab.fpc_from = (char *)(addr1); \
	ab.fpc_to = (char *)(addr2); \
	ab.fpc_count = (unsigned short)(cnt); \
	K_CMPMEM(&ab); \
	(rv) = (int)ab.fpc_count; \
}
#endif	ASM_INCLUDE

/* X_PROMRAM */

/* packet buffer allocation types: */
#define	PT_NTYPES	16	/* total number of types defined below */
#define	PT_FREE		0	/* should be on free list */
#define	PT_ABUS		1	/* received AppleTalk packet */
#define	PT_ENET		2	/* received Ethernet packet */
#define	PT_ARP		3	/* ARP packet */
#define	PT_DATA		4	/* general data */
#define	PT_ERBF		5	/* awaiting Ethernet receive packet */
#define	PT_ETBF		6	/* awaiting Ethernet transmit complete */
#define	PT_MALLOC	7	/* buffer allocated by malloc() */
#define	PT_UNUSED1	8	/* spare, for future use or debugging */
#define	PT_UNUSED2	9	/* spare, for future use or debugging */
#define	PT_UNUSED3	10	/* spare, for future use or debugging */
#define	PT_UNUSED4	11	/* spare, for future use or debugging */
#define	PT_UNUSED5	12	/* spare, for future use or debugging */
#define	PT_UNUSED6	13	/* spare, for future use or debugging */
#define	PT_UNUSED7	14	/* spare, for future use or debugging */
#define	PT_UNUSED8	15	/* spare, for future use or debugging */

#ifndef	ASM_INCLUDE
struct fp_bufinfo {
	struct pbuf **fpb_pfree;/* beginning of the free list */
	struct pqueue *fpb_pq;	/* received buffers queue (both networks) */
	struct pqueue *fpb_sendq;/* Ethernet transmit queue */
	unsigned short	fpb_bsize;	/* size of a buffer including header */
	unsigned short	fpb_pbnavail;	/* total # of pbufs initialized */
	unsigned long	fpb_pbndrops;	/* times failed to find space */
	unsigned short	fpb_pbntypes[PT_NTYPES];
			/* type specific pbuf allocations */
};
#endif	ASM_INCLUDE

/* NOTE - SNAMESIZE used in fp_ident as well */
#define	SNAMESIZE	21	    /* extra char for null at end */
#define	ZNAMESIZE	33	    /* extra char for null at end */
#define	FNAMESIZE	33	/* extra char for null at end */
#define	OPTSIZE	32	/* number of bytes for option parameters */

#ifndef	ASM_INCLUDE
/*
** WARNING: this size of this structure MUST be adjusted to
** max lap size (586).  adjust fps_spare as necessary.
*/
struct fp_state {
	unsigned short	fps_atnet;  /* current net number for AppleTalk side */
	unsigned short	fps_etnet;  /* current net number for Ethernet side */
	unsigned char	fps_valid;  /* following AppleTalk node number valid */
	unsigned char	fps_node;   /* current AppleTalk LAP node number */
	unsigned char	fps_netw;   /* network number (not used) */
	unsigned char	fps_bridge; /* last known bridge num on net if any */
	unsigned char	fps_ether[6]; /* current ethernet address */
	char	fps_name[SNAMESIZE];/* ascii name of the gateway */
	char	fps_file[SNAMESIZE];/* ascii name of srec file last loaded */
	unsigned char	fps_pforce; /* non-zero forces execution of prom loop */
	unsigned char	fps_reserve;	/* even pad */
	unsigned char	fps_unused[4];
	char	fps_atzone[ZNAMESIZE]; /* zone name for AppleTalk side */
	char	fps_etzone[ZNAMESIZE]; /* zone name for Ethernet side */
	unsigned char	fps_ETvalid;  /* EtherTalk node number valid */
	unsigned char	fps_ETnode;   /* EtherTalk LAP node number */
	short		fps_autoconfig;		/* auto-config switch */
	short		fps_autoboot;		/* auto-boot switch */
	unsigned long	fps_options;		/* option flags */
	char		fps_optparam[OPTSIZE];	/* optional parameters */
	
	/* box specific data */
	
	long	fps_sn;		/* serial number of this box */
	long	fps_date;	/* time/date of last configuration */
	short	fps_type;	/* 0 = AppleTalk Only, 1 = IP Subnet, 2 = KIP */
	char	fps_config[FNAMESIZE];	/* name of config file for this box */
	char	fps_1align;	/* pad for compiler */
	
	char	fps_udpzone[ZNAMESIZE];	/* UDP AppleTalk zone name */
	char	fps_2align;	/* pad for compiler */
	
	/* IP & KIP parameters */
	
	unsigned long	fps_ipdefrouter;/* address of default IP router */
	unsigned long	fps_ipaddress;	/* Ethernet IP address of FastPath */
	unsigned long	fps_ATipaddress;/* AppleTalk IP address of FastPath */
	unsigned long	fps_ipbroadcast;/* IP broadcast address */
	unsigned long	fps_ipsubmask;	/* IP subnet mask */
	unsigned long	fps_ipkipserver;/* IP address of administrator host */	
	unsigned short	fps_udpnet;	/* UDP AppleTalk net number */
	unsigned char	fps_udpnode;	/* UDP AppleTalk node number */
	unsigned char	fps_3align;	/* padding */
	    
	unsigned long	fps_nameserver;	/* IP address of name server */
	unsigned long	fps_fileserver;	/* IP address of file server */
	long	fps_lp1;	/* local parameter #1 */
	long	fps_lp2;	/* local parameter #2 */
	long	fps_lp3;	/* local parameter #3 */
	long	fps_lp4;	/* local parameter #4 */
	short	fps_ndynamics;	/* number of dynamically assigned
				** addresses for IP assignment on EtherTalk
				*/
	short	fps_nstatics;	/* number of statically assigned
				** addresses served by this box
				*/
	unsigned char	fps_spare[278];	/* available for future use */
	unsigned long	fps_cfgsum;	/* configuration area checksum */
};

/*
** new abstats structure, corresponding to Appletalk version 49
*/
struct fp_abstats {
	int IntCount;		/* receive interrupt count */
	int AbortCount;		/* abort interrupt count */
	int SpurCount;		/* spurrious interrupt count */
	int RcvCount;		/* good data packets received */
	int XmitCount;		/* data packets transmitted */
	int CRCCount;		/* bad CRC (all packets) */
	int OvrCount;		/* receive overruns (all packets) */
	int UndCount;		/* transmit underruns (all packets) */
	int NoHandCnt;		/* No protocol handler for packet */
	int LenErrCnt;		/* Packet length does not match header's */
	int BadCount;		/* Bad packets seen */
	int CollsnCount;	/* Number of assumed collisions */
	int DeferCount;		/* Number of times deferred to other packets */
#ifdef notdef
/* These two aren't in the 4.1 roms */
	int IdleTOCount;	/* Timed out waiting for end of packet */
	int BadDDP;		/* Bad DDP packet */
#endif
	int NoDtaCount;		/* No packet seen after RTS in */
	int RandomCTS;		/* Unsolicted CTS */
};

/*
**	the max size for the following structure is 64
*/
struct fp_promram {
	short	fpr_count;	    	/* number of valid ptrs that follow */
	struct fp_table	**fpr_jtable;	/* jump table */
	struct fp_bufinfo *fpr_bufs;	/* buffer manager vector */
	struct fp_state *fpr_state;	/* Prompt program's state vector */
	struct fp_abstats *fpr_abstats;	/* AppleTalk statistics vector */
	struct fp_iestats *fpr_iestats;	/* Ethernet statistics vector */
	char	*fpr_1debug;	    	/* first level debug flag */
	char	*fpr_2debug;	    	/* second level debug flag */
	char	*fpr_3debug;	    	/* third level debug flag */
	struct fp_ddpstats *fpr_ddpstats;/* DDP statistics vector */
	char	fpr_unused[26];    	/* remaining ptrs are not defined yet */
};

/* X_RESET */
/* no parameters */

/* X_USER0, X_USER1, X_USER2, X_USER3, X_USER4, X_USER5, X_USER6, X_USER7 */
/* parameters (if any) defined by user */

/* X_BUFGET */
struct fp_bget {
	struct pbuf *fpg_buf;	/* address of buffer returned */
	short	fpg_type;	/* type of buffer to be "gotten" */
};

#define	K_PGET(type,buf) { \
	struct fp_bget bg; \
	bg.fpg_type = (type); \
	K_BUFGET(&bg); \
	(buf) = bg.fpg_buf; \
}

/* X_BUFFREE */
struct fp_bfree {
	struct pbuf *fpf_buf;	/* address of buffer to be freed */
	struct pbuf *fpf_nxt;	/* the freed buffer's link before it was freed*/
};

#define	K_PFREE(buf) { \
	struct fp_bfree bf; \
	bf.fpf_buf = (buf); \
	K_BUFFREE(&bf); \
}

#define	K_PFREEN(buf,nxt) { \
	struct fp_bfree bf; \
	bf.fpf_buf = (buf); \
	K_BUFFREE(&bf); \
	(nxt) = bf.fpf_nxt; \
}

/* X_BUFENQ and  X_BUFDEQ */
struct fp_bqueue {
	struct pqueue *fpq_q;	/* addr of queue to enqueue to / dequeue from */
	struct pbuf *fpq_buf;	/* addr of buffer to be enqueued or dequeued */
};

#define	K_PENQ(level,head,buf) { \
	struct fp_bqueue bq; \
	short pr; \
	bq.fpq_q = (head); \
	bq.fpq_buf = (buf); \
	pr = (level); \
	K_SPL(&pr);	 \
	K_BUFENQ(&bq); \
	K_SPLX(&pr); \
}

#define	K_PENQNP(head,buf) { \
	struct fp_bqueue bq; \
	bq.fpq_q = (head); \
	bq.fpq_buf = (buf); \
	K_BUFENQ(&bq); \
}

#define	K_PDEQ(level,head,buf) { \
	struct fp_bqueue bq; \
	short pr; \
	bq.fpq_q = (head); \
	pr = (level); \
	K_SPL(&pr);	 \
	K_BUFDEQ(&bq); \
	K_SPL(&pr); \
	(buf) = bq.fpq_buf; \
}

#define	K_PDEQNP(head,buf) { \
	struct fp_bqueue bq; \
	bq.fpq_q = (head); \
	K_BUFDEQ(&bq); \
	(buf) = bq.fpq_buf; \
}

/* X_ERR */
/* no parameters */

/* X_IDLE */
/* no parameters */

/* X_KLAP */
/* The parameter is the address of a pbuf structure. See pbuf.h. */

/* X_WHO */
/* no parameters */

/* X_CA86 */
/* no parameters */

/* X_RES86 */
/* no parameters */

/* X_CLRINT */
/* no parameters */

/* X_RCSID */
/* The parameter is the address of a character array which is filled
   in with the current RCS identification string of this PROM version. */

/* X_EXPROM */
/* no parameters */

/* X_INIPROM */
/* no parameters */

/* X_RES8530 */
/* no parameters */

/* X_DMTSERV */
/* no parameters */

/* X_SREC */
/* The parameter is the address of a character array which contains
   the S-record to be interpreted and used by the gateway */

/* X_SPL */
/* The parameter is the address of a short which becomes the next processor
   priority level. The previous priority level is returned at same location */
#endif	ASM_INCLUDE

/* macros for various spl options */
#define SPL0_VAL	0x2000
#define SPLIE_VAL	0x2200
#define SPLABUS_VAL	0x2500
#define SPLIMP_VAL	0x2700

#ifndef	ASM_INCLUDE
#define	K_SPL0(a) { \
	*(a) = SPL0_VAL; \
	K_SPL(a); \
}

#define	K_SPLIE(a) { \
	*(a) = SPLIE_VAL; \
	K_SPL(a); \
}
#define	K_SPLABUS(a) { \
	*(a) = SPLABUS_VAL; \
	K_SPL(a); \
}

#define	K_SPLIMP(a) { \
	*(a) = SPLIMP_VAL; \
	K_SPL(a); \
}

#define	K_SPLX(a) { \
	K_SPL(a); \
}

/* X_LED */
struct fp_led {
	char	fpl_leds;		/* bit field: each bit is an led */
	char	fpl_state;		/* LED_ON, LED_OFF, LED_TOGGLE */
};
#endif	ASM_INCLUDE

/* constants for fpl_onoff */
#define	LED_OFF		0
#define	LED_ON		1
#define	LED_TOGGLE	2		/* if on, off. if off, on */

#ifndef	ASM_INCLUDE
/* macros for led calls */
#define	K_LEDON() { \
	struct fp_led fpl; \
	fpl.fpl_leds = 0; /* currently not used (only one led) */ \
	fpl.fpl_state = LED_ON; \
	K_LED(&fpl); \
}

#define	K_LEDOFF() { \
	struct fp_led fpl; \
	fpl.fpl_leds = 0; /* currently not used (only one led) */ \
	fpl.fpl_state = LED_OFF; \
	K_LED(&fpl); \
}

#define	K_LEDTOGGLE() { \
	struct fp_led fpl; \
	fpl.fpl_leds = 0; /* currently not used (only one led) */ \
	fpl.fpl_state = LED_TOGGLE; \
	K_LED(&fpl); \
}

/* X_RAND */
/* The parameter is the address of a long integer which has a new random
   number in it when the call returns. */

/* X_SENDF */
/* The parameter is the address of a stack location which contains a format
   string address and followed by the variable number of arguments which are
   required by that format string */

/* X_DMSG */
/* The parameter is a pointer to a 586 byte area in which to copy the
   messages. */

/* X_MEMSEG, X_MALLOC, X_FREE */
struct fp_malloc {
	union {
		long	fpo_size;	 /* bytes, for memseg and malloc */
		unsigned char *fpo_area; /* ptr to area, for free */
	} fpo_parm;
};

#define	MEMSEG(cast_type,kcp,kss) { \
	struct fp_malloc xyz0; \
	xyz0.fpo_parm.fpo_size = (kss); \
	K_MEMSEG(&xyz0); \
	(kcp) = (cast_type)xyz0.fpo_parm.fpo_area; \
}

#define	MALLOC(cast_type,kcp,kss) { \
	struct fp_malloc xyz0; \
	xyz0.fpo_parm.fpo_size = (kss); \
	K_MALLOC(&xyz0); \
	(kcp) = (cast_type)xyz0.fpo_parm.fpo_area; \
}

#define	FREE(kcp) { \
	struct fp_malloc xyz0; \
	xyz0.fpo_parm.fpo_area = (unsigned char *)(kcp); \
	K_FREE(&xyz0); \
}
#endif	ASM_INCLUDE

/*
** 	X_IE_INIT
**
**	ethernet initialization options:
*/
#define	STANDARD	0x0000		/* standard config */
#define	NO_CRS		0x0008		/* transmit even if no carrier */
#define	PROMISCUOUS	0x0001		/* promiscuous mode */

#ifndef	ASM_INCLUDE
struct	fp_ieinit {
	unsigned short fpie_options;	/* one of:
					** {STANDARD, NO_CRS, PROMISCUOUS} */
	unsigned char *fpie_etheraddr;	/* ethernet address */
	struct pqueue *fpie_recq;	/* recevie queue to use */
	int	fpie_nbufs;		/* number of buffers to use */
};

#define	IE_INIT(O,E,Q,N)	{ \
	struct	fp_ieinit arg; \
	arg.fpie_options = (O);	/* options */ \
	arg.fpie_etheraddr = (E);	/* ethernet address */ \
	arg.fpie_recq = (Q);		/* receive queue to use */ \
	arg.fpie_nbufs = (N);		/* number of buffers to use */ \
	K_IE_INIT(&arg); \
}

/* X_IEXSTART */
	/* takes pbuf as parameter */

/* X_KLAP2 - version 2.0 of KLAP allows KLAP on ethernet: */
struct	fp_klap {
	struct pbuf **kl_pbuf;	/* pkt handle - contents set to 0 if freed */
	struct ifnet *kl_ifp;	/* interface received on */
};

#define	KLAP2(P,IFP)	{ \
	struct	fp_klap arg; \
	arg.kl_pbuf = (P);	/* packet handle (struct **pbuf) */ \
	arg.kl_ifp = (IFP);	/* interface received on */ \
	K_KLAP2(&arg); \
}
#endif	ASM_INCLUDE

/* X_PROM1_CHECK */
	/* takes pointer to int as parameter - sets to 1 if PROM1 socket
	** populated, otherwise 0.
	*/
#define	MAGIC_PROM1 0x4b465053  	/* this must be first long in PROM1
					** for PROM0 to execute it
					*/

#ifndef	ASM_INCLUDE
/* X_PROM1_EXECUTE -	no parameters */

/* X_ARPINIT */
struct fp_arp_init {
	int options;
	struct Addr *address;
};
#endif	ASM_INCLUDE
	/* the "options" parameter consists of one or more of the
	** following options or'ed together:
	*/
#define	ARPOPT_IP_OFF		0x0000
#define	ARPOPT_IP_ON		0x0001
#define ARPOPT_FAKEIP_ON	0x0002

#ifndef	ASM_INCLUDE
#define ARPINIT(OPT, ADDR) { \
	struct fp_arp_init arg; \
	arg.options = (OPT); \
	arg.address = (struct Addr *) (ADDR); \
	K_ARPINIT(&arg); \
}

/* X_ARPINPUT */
struct	fp_arpin {
	struct pbuf **arp_pbuf;	/* pkt handle - contents set to 0 if freed */
	struct ifnet *arp_ifp;	/* hardware interface received on */
	unsigned short arp_afin;	/* protocol interface received on */
};

#define	ARPINPUT(P,IFP,AFIN) { \
	struct	fp_arpin arg; \
	arg.arp_pbuf = (P); \
	arg.arp_ifp = (IFP); \
	arg.arp_afin = (AFIN); \
	K_ARPINPUT(&arg); \
}

/* X_ARPRESOLVE */
struct	fp_arpresolve {
	struct pbuf **arpr_pbuf;/* pkt handle - contents set to 0 if freed */
	struct ifnet *arpr_ifp;	/* hardware interface received on */
	unsigned long *arpr_pdst;	/* protocol destination (value) */
	unsigned char *arpr_hdst;	/* hardware destination (result) */
	short *isresolved;	/* contents set to 1 if resolved */
};

#define	ARPRESOLVE(P,IFP,PDST,HDST,ISRESOLVED) { \
	struct	fp_arpresolve arg; \
	arg.arpr_pbuf = (P); \
	arg.arpr_ifp = (IFP); \
	arg.arpr_pdst = (PDST); \
	arg.arpr_hdst = (HDST); \
	arg.isresolved = (ISRESOLVED); \
	K_ARPRESOLVE(&arg); \
}

/* X_ISIPAARP */
struct	fp_isipaarp {
	struct pbuf *pkt;	/* input ARP for IP resolution */
	short *isaarp;	/* contents set to 1 if an AARP masquerading
			** as IP ARP, o'wise set to 0
			*/
};

#define	ISIPAARP(P,ANS) { \
	struct	fp_isipaarp arg; \
	arg.pkt = (P);		/* VALUE parameter */ \
	arg.isaarp = (ANS);	/* RESULT parameter */ \
	K_ISIPAARP(&arg); \
}

/* X_ARPDUMP */
	/* no parameters */

/* X_ETINIT */
	/* parameter is pointer to if_net structure of EtherTalk interface.
	** if_dnode is a VALUE-RESULT, initial value is taken as a hint
	** for node-finding.  if_addr[3] is a RESULT - this is the
	** EtherTalk node number saved as an IP address, used in
	** earlier implementations, and retained for backwards compatibility.
	*/
#endif	ASM_INCLUDE

/* X_TIMING */
#define	MC68008	1
#define	MC68000	2

#ifndef	ASM_INCLUDE
struct fp_timing {
	int processor;		/* processor type */
	int hertz;		/* processor clock speed in hertz */
};

/* X_ROUTEDDPINIT */
struct fp_routeddpinit {
	struct ifnet *ifab;		/* AppleTalk interface structure */
	struct ifnet *ifie;		/* Ethernet interface structure */
	struct ifnet *ifabip;		/* AppleTalk IP interface structure */
	int *iscombgw;			/* is combined gateway? */
	struct pqueue *pq;		/* incoming packet queue */
};

#define ROUTEDDPINIT(IFAB, IFIE, IFABIP, ISCOMBGW, PQ) { \
	struct fp_routeddpinit arg; \
	arg.ifab = (IFAB); \
	arg.ifie = (IFIE); \
	arg.ifabip = (IFABIP); \
	arg.iscombgw = (ISCOMBGW); \
	arg.pq = (PQ); \
	K_ROUTEDDPINIT(&arg); \
}

/* X_ROUTEDDP */
struct fp_routeddp {
	struct pbuf **p;	/* LAP data of packet to route */
	unsigned char lapdest;		/* short ddp params from lap */
	unsigned char lapsrc;
	unsigned char laptype;
	struct ifnet *fromifp;	/* interface packet came from */
};

#define ROUTEDDP(PKT, DST, SRC, TYPE, IFP) { \
	struct fp_routeddp arg; \
	arg.p = (PKT); \
	arg.lapdest = (DST); \
	arg.lapsrc = (SRC); \
	arg.laptype = (TYPE); \
	arg.fromifp = (IFP); \
	K_ROUTEDDP(&arg); \
}

/* X_NBPINPUT */
/* X_RTMPINPUT */
/* X_RTMPRESPONSE */
/* X_ZIPINPUT */
/* X_ATPINPUT */
/* X_ECHOINPUT */
struct fp_input {
	struct pbuf **p;	/* pointer to the incoming packet */
	struct gen_ddp *ddp_info;	/* generic ddp */
	struct ifnet *ifp;	/* interface packet came from */
};

/* X_NBPINIT */
/* no parameters */

#define NBPINPUT(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_NBPINPUT(&arg); \
}

/* X_RTMPINIT */
struct fp_rtmpinit {
	short autoconf_on;		/* is autoconfig turned on? */
	int delay;			/* autoconfig delay */
	struct ifnet *ifnet,		/* linked list of interface structs */
		*ifab, 			/* AppleTalk interface */
		*ifie;			/* Ethernet interface */
};

#define RTMPINIT(AUTOCONF_ON, DELAY, IFNET, IFAB, IFIE) { \
	struct fp_rtmpinit arg; \
	arg.autoconf_on = (AUTOCONF_ON); \
	arg.delay = (DELAY); \
	arg.ifnet = (IFNET); \
	arg.ifab = (IFAB); \
	arg.ifie = (IFIE); \
	K_RTMPINIT(&arg); \
}

#define RTMPINPUT(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_RTMPINPUT(&arg); \
}

#define RTMPRESPONSE(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_RTMPRESPONSE(&arg); \
}

/* X_RTMPTIMER */
/* no parameters */

/* X_ZIPINIT */
struct fp_zipinit {
	int atzconf,			/* AppleTalk zone configured? */
		etzconf;		/* Ethernet zone configured? */
	struct ifnet *ifab,		/* AppleTalk interface struct */
		*ifie;			/* Ethernet interface struct */
};

#define ZIPINIT(ATZCONF, ETZCONF, IFAB, IFIE) { \
	struct fp_zipinit arg; \
	arg.atzconf = (ATZCONF); \
	arg.etzconf = (ETZCONF); \
	arg.ifab = (IFAB); \
	arg.ifie = (IFIE); \
	K_ZIPINIT(&arg); \
}

#define ZIPINPUT(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_ZIPINPUT(&arg); \
}

/* X_ZIPTIMER */
/* no parameters */

/* X_ATPINIT */
/* no parameters */

#define ATPINPUT(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_ATPINPUT(&arg); \
}

/* X_ECHOINIT */
struct fp_echoinit {
	struct ifnet *ifie;		/* Ethernet interface struct */
};

#define ECHOINIT(IFIE) { \
	struct fp_echoinit arg; \
	arg.ifie = (IFIE); \
	K_ECHOINIT(&arg); \
}

#define ECHOINPUT(PKT, DDP, IFP) { \
	struct fp_input arg; \
	arg.p = (PKT); \
	arg.ddp_info = (DDP); \
	arg.ifp = (IFP); \
	K_ECHOINPUT(&arg); \
}

/* X_DDPIPINIT */
struct fp_ddpIPinit {
	struct fp_promram *pvars;		/* pointer to prom vars */
	struct Addr *macipbcast;		/* special bcast address */
	unsigned char *etheraddr;		/* our ethernet address */
	unsigned long *gwoptions;		/* gateway options */
	unsigned short atnet;			/* AppleTalk net number */
	struct ifnet *ifabip,		/* AppleTalk IP interface struct */
		*ifieip;		/* Ethernet IP interface struct */
	int *iscombgw;		/* is this a combined gateway? */
};

#define DDPIPINIT(PVARS, MACIPBCAST, ETHERADDR, GWOPTIONS, ATNET, IFABIP, IFIEIP, ISCOMBGW) { \
	struct fp_ddpIPinit arg; \
	arg.pvars = (PVARS); \
	arg.macipbcast = (MACIPBCAST); \
	arg.etheraddr = (ETHERADDR); \
	arg.gwoptions = (GWOPTIONS); \
	arg.atnet = (ATNET); \
	arg.ifabip = (IFABIP); \
	arg.ifieip = (IFIEIP); \
	arg.iscombgw = (ISCOMBGW); \
	K_DDPIPINIT(&arg); \
}

/* X_AUTOCINIT */
struct fp_autocinit {
	int *delay;			/* rtmp intervals before autoconf */
	unsigned char *etheraddr;		/* our ethernet address */
	struct ifnet *ifab;		/* AppleTalk interface */
	struct ifnet *ifie;		/* Ethernet interface */
};

#define AUTOCINIT(DELAY, ETHERADDR, IFAB, IFIE) { \
	struct fp_autocinit arg; \
	arg.delay = (DELAY); \
	arg.etheraddr = (ETHERADDR); \
	arg.ifab = (IFAB); \
	arg.ifie = (IFIE); \
	K_AUTOCINIT(&arg); \
}

/* X_HASHINIT */
/* no parameters */

/* X_NEWHASHTAB */
struct fp_newtab {
	int (*key_func)();		/* pointer to hash function */
	int (*match_func)();	/* pointer to key equality function */
	unsigned short size;		/* number of buckets to allocate */
	struct hashtab **table;	/* the new table */
};

#define NEWHASHTABLE(KEY, MATCH, SIZE, TAB) { \
	struct fp_newtab arg; \
	arg.key_func = (KEY); \
	arg.match_func = (MATCH); \
	arg.size = (SIZE); \
	arg.table = (TAB); \
	K_NEWHASHTABLE(&arg); \
}

/* X_LOOKUP */
struct fp_lkuphash {
	unsigned char *key;		/* the key to hash */
	struct entry **prev;	/* return entry before sought entry */
	struct hashtab *tab;	/* the table to search in */
	struct entry **entry;	/* the sought entry */
};

#define LOOKUP(KEY, PREV, TAB, ENTRY) { \
	struct fp_lkuphash arg; \
	arg.key = (unsigned char *)(KEY); \
	arg.prev = (struct entry **)(PREV); \
	arg.tab = (TAB); \
	arg.entry = (struct entry **)(ENTRY); \
	K_LOOKUP(&arg); \
}

/* X_ADD */
struct fp_addhash {
	unsigned char *key;		/* the key of the entry to add */
	struct entry *entry;	/* the entry to add */
	struct hashtab *tab;	/* the table to add to */
};

#define ADD(KEY, ENTRY, TAB) { \
	struct fp_addhash arg; \
	arg.key = (unsigned char *)(KEY); \
	arg.entry = (struct entry *)(ENTRY); \
	arg.tab = (TAB); \
	K_ADD(&arg); \
}

/* X_REMOVE */
struct fp_delhash {
	unsigned char *key;		/* the key of the entry to delete */
	struct hashtab *tab;	/* the table to delete from */
};

#define REMOVE(KEY, TAB) { \
	struct fp_delhash arg; \
	arg.key = (unsigned char *)(KEY); \
	arg.tab = (TAB); \
	K_REMOVE(&arg); \
}

/* X_FIRST */
struct fp_firsthash {
	struct hashtab *tab;	/* table to search in */
	struct entry **entry;	/* first entry in table */
};

#define FIRST(TAB, ENTRY) { \
	struct fp_firsthash arg; \
	arg.tab = (TAB); \
	arg.entry = (struct entry **)(ENTRY); \
	K_FIRST(&arg); \
}

/* X_NEXT */
struct fp_nexthash {
	unsigned char *key;		/* key of current entry */
	struct entry *entry;	/* the current entry */
	struct hashtab *tab;	/* the table to search in */
	struct entry **nextentry;    /* the next entry in the table */
};

#define NEXT(KEY, ENTRY, TAB, NEXT) { \
	struct fp_nexthash arg; \
	arg.key = (unsigned char *)(KEY); \
	arg.entry = (struct entry *)(ENTRY); \
	arg.tab = (TAB); \
	arg.nextentry = (struct entry **)(NEXT); \
	K_NEXT(&arg); \
}

/* X_NETLOOKUP */
struct fp_netlookup {
	unsigned short net;		/* net number */
	struct rtmptab **lastentry;	/* RESULT parameter */
	struct rtmptab **the_net;	/* return value */
};

#define NETLOOKUP(NET, LASTENTRY, THE_NET) { \
	struct fp_netlookup arg; \
	arg.net = (NET); \
	arg.lastentry = (LASTENTRY); \
	arg.the_net = (THE_NET); \
	K_NETLOOKUP(&arg); \
}

/* X_RMRTMP */
struct fp_rmrtmp {
	struct rtmptab *tp;		/* the entry to remove */
};

#define RMRTMP(TP) { \
	struct fp_rmrtmp arg; \
	arg.tp = (TP); \
	K_RMRTMP(&arg); \
}

/* X_RTMPREPLACE */
struct fp_rtmpreplace {
	struct rtmptab *tp;		/* entry to replace */
	int hops;			/* number of hops */
	struct ifnet *ifp;		/* interface for entry */
	unsigned char nodenum;		/* next IR for entry */
	unsigned short net;			/* net number */
	struct rtmptab **new_entry;	/* new entry */
};

#define RTMPREPLACE(TP, HOPS, IFP, NODENUM, NET, NEW_ENTRY) { \
	struct fp_rtmpreplace arg; \
	arg.tp = (TP); \
	arg.hops = (HOPS); \
	arg.ifp = (IFP); \
	arg.nodenum = (NODENUM); \
	arg.net = (NET); \
	arg.new_entry = (NEW_ENTRY); \
	K_RTMPREPLACE(&arg); \
}

/* X_ADDNET */
struct fp_addNet {
	unsigned char *zname;  	/* a Pascal string referring to the zone */
	struct rtmptab *net;	/* the net to add to the list */
};

#define ADDNET(ZNAME, NET) { \
	struct fp_addNet arg; \
	arg.zname = (unsigned char *)(ZNAME); \
	arg.net = (NET); \
	K_ADDNET(&arg); \
}

/* X_RMNET */
struct fp_rmNet {
	struct zitEntry *zone;		/* the zone to remove from */
	struct rtmptab *net;		/* the net to be removed */
	struct rtmptab *prev; 		/* net before the net to be removed */
};

#define RMNET(ZONE, NET, PREV) { \
	struct fp_rmNet arg; \
	arg.zone = (ZONE); \
	arg.net = (NET); \
	arg.prev = (PREV); \
	K_RMNET(&arg); \
}

/* X_FINDZONE */
struct fp_findzone {
	unsigned char *zone;
	struct zitEntry **foundzone;
};

#define FINDZONE(ZONE, FOUNDZONE) { \
	struct fp_findzone arg; \
	arg.zone = (unsigned char *)(ZONE); \
	arg.foundzone = (FOUNDZONE); \
	K_FINDZONE(&arg); \
}

/* X_AUTOCONF */
/* the parameter is a pointer to the interface structure
** of the interface to be configured.
*/


/* X_RESET_AUTOCONF */
struct fp_resetautoc {
	struct ifnet *ifp;	/* pointer to interface to reset */
	int *delay;		/* delay before autoconfiguring */
};

#define RESET_AUTOCONF(IFP, DELAY) { \
	struct fp_resetautoc arg; \
	arg.ifp = (IFP); \
	arg.delay = (DELAY); \
	K_RESET_AUTOCONF(&arg); \
}

/* X_DDPREPLY */
struct fp_ddpreply {
	struct pbuf **pkt;		/* the packet to send */
	struct gen_ddp *gddp;    	/* generic ddp header for packet */
	struct ifnet *ifp;		/* interface packet came from */
};

#define DDPREPLY(PKT, GDDP, IFP) { \
	struct fp_ddpreply arg; \
	arg.pkt = (PKT); \
	arg.gddp = (GDDP); \
	arg.ifp = (IFP); \
	K_DDPREPLY(&arg); \
}

/* X_ROUTEIP */
struct fp_routeip {
	struct pbuf **pkt;		/* value result param */
	struct ifnet *ifp;		/* source interface */
	int isbcast;			/* is packet a broadcast? */
};

#define ROUTEIP(PKT, IFP, ISBCAST) { \
	struct fp_routeip arg; \
	arg.pkt = (PKT); \
	arg.ifp = (IFP); \
	arg.isbcast = (ISBCAST); \
	K_ROUTEIP(&arg); \
}

/* X_ISSAMEZONE */
struct fp_issamezone {
 	struct zitEntry *zone;		/* zone to compare with */
	unsigned char *zname;			/* a Pascal string */
	unsigned short *same;		/* are the zones the same? */
};

#define ISSAMEZONE(ZONE, ZNAME, SAME) { \
	struct fp_issamezone arg; \
	arg.zone = (ZONE); \
	arg.zname = (unsigned char *)(ZNAME); \
	arg.same = (SAME); \
	K_ISSAMEZONE(&arg); \
}
#endif	ASM_INCLUDE

/* X_CHECKSUM */

#define BYTESUM	1
#define WORDSUM	2
#define LONGSUM	3

#ifndef	ASM_INCLUDE
struct fp_checksum {
	unsigned char *cs_loaddr;	/* address of first byte */
	unsigned char *cs_hiaddr;	/* address of last byte */
	short cs_size;	/* one of: {BYTESUM, WORDSUM, LONGSUM} */
	unsigned long *cs_answptr;	/* pointer to storage for result */
};

#define	CHECKSUM(LO,HI,OPT,RESULTPTR) {\
	struct fp_checksum arg;\
	arg.cs_loaddr = (LO);\
	arg.cs_hiaddr = (HI);\
	arg.cs_size = (OPT);\
	arg.cs_answptr = (RESULTPTR);\
	K_CHECKSUM(&arg);\
}
#endif	ASM_INCLUDE

/* X_WHERE2 */

#define	FPMODEL123	1
#define	FPMODEL4	2
#define	WHERE2UNUSED	24

#ifndef	ASM_INCLUDE
struct fp_where2 {
	short	fpw2_model;	/* model: one of {FPMODEL123, FPMODEL4}  */
	/* following is zero for FPMODEL123: */
	unsigned char	*fpw2_enetprom;	/* ethernet address ROM on KFPS-4 */
	unsigned char	*fpw2_exrambot;	/* expansion ram first word */
	unsigned char	*fpw2_exramtop;	/* expansion ram last word */
	unsigned char	fpw2_spare[WHERE2UNUSED];	/* for future use */
};

/* X_GETCFGSUM	- takes pointer to unsigned long, computes checksum
		of configuration area and returns result */

/* X_SETCFGSUM	- recomputes and resets configuration area checksum.
		- no parameters */

/* X_DMSG	- argument is *char, copies contents of message log into
		string, which must be large enough (586 bytes) */

/* X_STATE	- argument is pointer to int, returns state of PROM,
		defined to be one of the following: */
#endif	ASM_INCLUDE

#define	BOOTME			1
#define	DOWNLOAD_VALID		2
#define	FORCE_PROM_EXECUTION	3
#define	PROM1_VALID		4
#define	BE_A_BRIDGE		5
#define	EXECUTING_BRIDGE	6
#define	EXECUTING_DOWNLOAD	7
#define	EXECUTING_PROM1		8

/* upper and lower bounds state var can take: */
#define	LBSTATE		1
#define	UBSTATE		8

/* X_HWSTATE -	takes pointer to unsigned long returns
		hardware status returned by selftests,
		formed by logically or'ing members from
		the following set: */

#define	SCC_BAD			0x01
#define	I82586_BAD		0x02
#define	BATTERY_LOW		0x04
#define	EXP_RAM_INSTALLED	0x08
#define	FUSE_BLOWN		0x10
#define	RAMTEST_FAILED		0x20

/* X_SENDFINIT -no parameters */

/* X_IESTATS */

/* array positions of various ethernet stats.
** Note:  scb errors counts are updated only by K_IESTAT call.
*/
#define	SCB_CRCERRS	0
#define	SCB_ALNERRS	1
#define	SCB_RSCERRS	2
#define	SCB_OVRNERRS	3
#define	IN_PACKETS	4
#define	OUT_PACKETS	5
#define	BAD_TRANSMIT	6
#define	OVERSIZE_FRAME	7
#define	SPUR_RU_READY	8
#define	SPUR_CU_ACTIVE	9
#define	SPUR_UNKNOWN	10
#define	BCAST_DROPS	11
#define	RCV_RESTARTS	12
#define	REINTERRUPTS	13
#define	ENET_BUF_REROUTE	14

/* These are only in the 4.1 roms - got them from Kinetics via a phone call */
#define ENET_PPN_DROP	15	/* tried to get ethernet buffer and failed */
#define XMIT_COLLSN		16
#define XMIT_DEFER	17
#define XMIT_DMA_UNDERRUNS	18
#define XMIT_MAX_COLLSN	19
#define XMIT_NO_CARRIER	20
#define XMIT_NO_CPS	21
#define XMIT_NO_SQE	22

#define	MAXIESTATS 25
#define	SIZEOFIESTATS ((MAXIESTATS*4)+4)

#ifndef	ASM_INCLUDE
struct fp_iestats {
	struct scb *fpi_scbptr;		/* status control block */
	int	fpi_stats[MAXIESTATS];	/* statistics array */
};
#endif	ASM_INCLUDE

/* X_DDPSTATS */

#define	BADATPSKT	0
#define	BADECHO_REQ	1
#define	BADHOPCNT	2
#define	BADKLAPREQ	3
#define	BADKLAPSKT	4
#define	BADRTMPREQ_SKT	5
#define	BADRTMP_SKT	6
#define	BADZIPSKT	7
#define	BAD_DDPTYPE	8
#define	BAD_DESTNET	9
#define	COPY_BCAST	10
#define	ECHOLONG_DROP	11
#define	ECHOSHORT_DROP	12
#define	LAPBCAST_DROP	13
#define	NBPLOOKUP_DROP	14
#define	NOBUF_CPBCAST	15
#define	RTMPREQ_DROP	16
#define	SHORTDDP_DROP	17
#define	TOOLONG_DDP	18
#define	TOOSHORT_DDP	19

#define	MAXDDPSTATS 30
#define	SIZEOFDDPSTATS (MAXDDPSTATS*4)

#ifndef	ASM_INCLUDE
struct fp_ddpstats {
	int	fpddp_stats[MAXDDPSTATS];	/* statistics array */
};
#endif	ASM_INCLUDE

/* X_AATWRITE */
	/* takes pbuf as parameter */

/* X_ALLBUFS */
	/* takes the address of the end of the download area, where
	** packet buffers can start.
	*/

/* X_MAKEBUFS */
	/* takes an array of unsigned longs, representing pairs
	** of the form (lo,hi), terminated by (0,0).
	*/

/* X_SIZEMEM */
	/* takes a pointer to an int as an arg, returns number of bytes
	** of memory installed.
	*/

/* X_SETACKLEN */
	/* argument is an int value.  Sets the length of the KLAP
	** portion of a packet returned by a user-implemented KLAP call.
	*/

/* X_IDENT */
#ifndef	ASM_INCLUDE
struct fp_ident {
	char	fpid_name[SNAMESIZE];	/* ascii name of the gateway */
	char	fpid_pad;		/* padding, SNAMESIZE is odd */
	unsigned char fpid_ether[6];	/* ethernet address of gw */
	long	fpid_sn;		/* serial number of this box */
	short	fpid_model;		/* model number */
	short	fpid_version;		/* version of the prom code */
	int	fpid_state;		/* operating state */
};
#endif	ASM_INCLUDE

/* X_SETMCAST */

/* maximum multicast addresses we can set up: */
#define	MAX_MCAST	16

#ifndef	ASM_INCLUDE
struct fp_mcast {
	unsigned short	fpmc_naddrs;	/* number of multicast addresses, 0
					** to turn off multicasting */
	unsigned char	fpmc_addrs[MAX_MCAST*6];
			/* packed array of enet addresses */
};
#endif	ASM_INCLUDE

/* X_NOTIMP -		no parameters */
